#include "mqtt_fun.h"
#include "socket.h"
#include "usart.h"
#include "w5500.h"
#include "ult.h"
#include "device.h"
#include "types.h"
#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include "MQTTPacket.h"
#include "StackTrace.h"
extern int MQTTSerialize_zero(unsigned char* buf, int buflen, unsigned char packettype);
extern uint8_t server_ip[4];//mqttipַ

/***************Ϣغ************************/

/**
* @brief  ͨTCPʽݵTCP
* @param  buf׵ַ
* @param  buflenݳ
* @retval С0ʾʧ
*/

/*Ϣ*/
int Subscribe_sendPacketBuffer(unsigned char* buf, int buflen)
{
  return send(SOCK_TCPS,buf,buflen);
}

/*Ϣ*/
int Published_sendPacketBuffer(unsigned char* buf, int buflen)
{
  return send(SOCK_TCPC,buf,buflen);
}

/**
* @brief  ʽTCP͵
* @param  bufݴ洢׵ַ
* @param  countݻ
* @retval С0ʾʧ
*/
int Subscribe_getdata(unsigned char* buf, int count)
{
	
     return recv(SOCK_TCPS,buf,count);
	
}

int Published_getdata(unsigned char* buf, int count)
{
  return recv(SOCK_TCPC,buf,count);
	
}

/**
* @brief  һsocketӵ
* @param  
* @retval С0ʾʧ
*/
int Subscribe_open(void)
{
  int32_t ret;
		//½һSocket󶨱ض˿5000
  ret = socket(SOCK_TCPS,Sn_MR_TCP,50000,0x00);
  if(ret != 1){
    printf("%d:Socket Error\r\n",SOCK_TCPS);
    while(1);
  }else{
    printf("%d:Opened\r\n",SOCK_TCPS);
  }
	

	while(getSn_SR(SOCK_TCPS)!=SOCK_ESTABLISHED)
	{
		 printf("connecting\r\n");
			//TCP
		 ret = connect(SOCK_TCPS,server_ip,1883);//˿ڱΪ1883
	}
  if(ret != 1){
    printf("%d:Socket Connect Error\r\n",SOCK_TCPS);
    while(1);
  }else{
    printf("%d:Connected\r\n",SOCK_TCPS);
  }		
	return 0;
}

int Published_open(void)
{
  int32_t ret;
  
  ret = socket(SOCK_TCPC,Sn_MR_TCP,5001,0x00);
	
  if(ret != 1){
    printf("%d:Socket1 Error1\r\n",SOCK_TCPC);
    while(1);
  }else{
    printf("%d:socket1 Opened\r\n",SOCK_TCPC);
  }

  
	while(getSn_SR(SOCK_TCPC)!=SOCK_ESTABLISHED)
	{
		 ret = connect(SOCK_TCPC,server_ip,1883);//˿ڱΪ1883
	}
  if(ret != 1){
    printf("%d:Socket Connect1 Error\r\n",SOCK_TCPC);
    while(1);
  }else{
    printf("%d:Connected1\r\n",SOCK_TCPC);
  }		
	return 0;
}

/**
* @brief  رsocket
* @param  
* @retval С0ʾرʧ
*/
int Subscribe_close(void)
{
 disconnect(SOCK_TCPS);
	printf("close0\n\r");

	while(getSn_SR(SOCK_TCPC)!=SOCK_CLOSED)
	{
		;
	}
  return 0;
}


int Published_close(void)
{
  disconnect(SOCK_TCPC);
	printf("close1\n\r");

	while(getSn_SR(SOCK_TCPC)!=SOCK_CLOSED)
	{
		;
	}
  return 0;
}


/*****************ƴӱ**********************/
//MQTTӺ
/************************************************************************
*
*passwordƴӷʽ
*1.ʹðƵɹߣĿļпɼ
*2.ֶƴӣ
*a:ƴӲ-----------ύclientIddeviceName
*  productKeytimestamptimestampΪǱѡֵƴӡ
*  ƴӽΪclientId12345deviceNamedeviceproductKeyalxxxxxxxxx
*b:------------ͨClient IDȷļܷʹ豸deviceSecret
*  ƴӽܡ豸deviceSecretֵΪabc123ܼʽΪ
*  hmacsha1(abc123,clientId12345deviceNamedeviceproductKeyalxxxxxxxxxx)
*
************************************************************************/
void make_con_msg(char* clientID,int keepalive, uint8 cleansession,char*username,char* password,unsigned char*buf,int buflen)
{
	int32_t len;
	MQTTPacket_connectData data = MQTTPacket_connectData_initializer;
  data.clientID.cstring = clientID;
	data.keepAliveInterval = keepalive;
	data.cleansession = cleansession;
	data.username.cstring = username;
	data.password.cstring = password;
	len = MQTTSerialize_connect(buf, buflen, &data);//ӱ
	return;
}
/*****************ƴӶı**************************************/
void make_sub_msg(char *Topic,unsigned char*msgbuf,int buflen)
{
	int msgid = 1;
	int req_qos = 0;
	unsigned char topic[100];
  MQTTString topicString= MQTTString_initializer;
	memcpy(topic,Topic,strlen(Topic));
	topicString.cstring = (char*)topic;
	//topicString.lenstring.len=4;
	MQTTSerialize_subscribe(msgbuf, buflen, 0, msgid, 1, &topicString, &req_qos);
	return;
}
/*********ƴӷ******************/
void make_pub_msg(char *Topic,unsigned char*msgbuf,int buflen,char*msg)
{
	unsigned char topic[100];
	int msglen = strlen(msg);
	MQTTString topicString = MQTTString_initializer;
	memset(topic,0,sizeof(topic));
	memcpy(topic,Topic,strlen(Topic));
	topicString.cstring = (char*)topic;
	MQTTSerialize_publish(msgbuf, buflen, 0, 2, 0, 0, topicString, (unsigned char*)msg, msglen); 
	return;
}
/********ƴPING*********************/
int  make_ping_msg(unsigned char* buf,int buflen)
{
   return MQTTSerialize_zero(buf, buflen, PINGREQ);
}
/******յACK*********/
int mqtt_decode_msg(unsigned char*buf)
{
	int rc = -1;
  MQTTHeader header = {0};
	header.byte = buf[0];
	rc = header.bits.type;
	return rc;
}
/****************ƴhamacsha1ַ**********************/
/**void hamacsha1(void)
{
	//MQTTPacket_connectData data = MQTTPacket_connectData_initializer;
	char buffer[2048];
	char mesbuf[2048];
	char *clientId = "192.168.207.115";
	char *deviceName = "MQTT1";
	char *productKey = "TKKMt4nMF8U";
	char *secret = "A2VmnqJab2XAZlntAxwjLxW0nNmOpHaQ";
	int timestap = 789;
	sprintf(buffer,"clientId%sdeviceName%sproductKey%stimestap%d",clientId,deviceName,productKey,timestap);
	printf("%s\r\n",buffer);

}**/

